# coding: utf-8
# Consumer Expenditure data - Group Stats and Transform

import numpy as np # linear algebra
import pandas as pd # data processing, CSV file I/O (e.g. pd.read_csv)

# first, loading  data
# data = pd.read_csv("C:\\work\\python\\Consumer_Exp_part1_100records_out.csv")
df = pd.read_csv("C:\\ConsumerExpenditureDemo\\Data\PythonBased\\Output\\Input_Consumer_Exp_part1.csv")
# data.head()
print df.head()
# print data.info()


# Aggregations

# f = {'A': {'my_sum': np.sum, 'my_max': np.max}, 'B': {'my_name': np.max}}
f = {'FINCBTXM': {'MaximumOfFINCBTXM': max}, 'FINATXEM': {'MaximumOfFINATXEM': max},
     'INC_RNKM': {'MaximumOfINC_RNKM': max}, 'FSMPFRMX': {'MaximumOfFSMPFRMX': max},
     'FOODPQ': {'SumOfFOODPQ': sum}, 'FOODCQ': {'SumOfFOODCQ': sum},
     'ALCBEVPQ': {'SumOfALCBEVPQ': sum}, 'ALCBEVCQ': {'SumOfALCBEVCQ': sum},
     'HOUSPQ': {'SumOfHOUSPQ': sum}, 'HOUSCQ': {'SumOfHOUSCQ': sum},
     'APPARPQ': {'SumOfAPPARPQ': sum}, 'APPARCQ': {'SumOfAPPARCQ': sum},
     'TRANSPQ': {'SumOfTRANSPQ': sum}, 'TRANSCQ': {'SumOfTRANSCQ': sum},
     'HEALTHPQ': {'SumOfHEALTHPQ': sum}, 'HEALTHCQ': {'SumOfHEALTHCQ': sum},
     'ENTERTPQ': {'SumOfENTERTPQ': sum}, 'ENTERTCQ': {'SumOfENTERTCQ': sum},
     'PERSCAPQ': {'SumOfPERSCAPQ': sum}, 'PERSCACQ': {'SumOfPERSCACQ': sum},
     'READPQ': {'SumOfREADPQ': sum}, 'READCQ': {'SumOfREADCQ': sum},
     'EDUCAPQ': {'SumOfEDUCAPQ': sum}, 'EDUCACQ': {'SumOfEDUCACQ': sum},
     'TOBACCPQ': {'SumOfTOBACCPQ': sum}, 'TOBACCCQ': {'SumOfTOBACCCQ': sum},
     'MISCPQ': {'SumOfMISCPQ': sum}, 'MISCCQ': {'SumOfMISCCQ': sum},
     'CASHCOPQ': {'SumOfCASHCOPQ': sum}, 'CASHCOCQ': {'SumOfCASHCOCQ': sum},
     'PERINSPQ': {'SumOfPERINSPQ': sum}, 'PERINSCQ': {'SumOfPERINSCQ': sum},
     }

data = df.groupby('CUID').agg(f)
# data = df.groupby('CUID', as_index=False).agg(f)
print data.head(10)
data.columns = data.columns.droplevel(0)
print data.info()
print data.head()
data.to_csv("C:\\ConsumerExpenditureDemo\\Data\PythonBased\\Output\\Consumer_Exp_part1_python_groupBy_out.csv")

#  ------- Transform stage ------
# it will loop through

data = data.assign(FOODP_CQ   = data['SumOfFOODPQ'] +data['SumOfFOODCQ'] )
data = data.assign(ALCBEVP_CQ = data['SumOfALCBEVPQ'] +data['SumOfALCBEVCQ'] )
data = data.assign(HOUSP_CQ   = data['SumOfHOUSPQ'] +data['SumOfHOUSCQ'] )
data = data.assign(TRANSP_CQ  = data['SumOfTRANSPQ'] + data['SumOfTRANSCQ'] )
data = data.assign(APPARP_CQ  = data['SumOfAPPARPQ'] +data['SumOfAPPARCQ'] )
data = data.assign(HEALTHP_CQ = data['SumOfHEALTHPQ'] + data['SumOfHEALTHCQ'] )
data = data.assign(ENTERTP_CQ = data['SumOfENTERTPQ'] + data['SumOfENTERTCQ'] )
data = data.assign(PERSCAP_CQ = data['SumOfPERSCAPQ'] +data['SumOfPERSCACQ'] )
data = data.assign(READP_CQ   = data['SumOfREADPQ'] + data['SumOfREADCQ'] )
data = data.assign(EDUCAP_CQ = data['SumOfEDUCAPQ'] + data['SumOfEDUCACQ'] )
data = data.assign(TOBACCP_CQ = data['SumOfTOBACCPQ'] +data['SumOfTOBACCCQ'] )
data = data.assign(MISCP_CQ   = data['SumOfMISCPQ']  + data['SumOfMISCCQ'] )
data = data.assign(CASHCOP_CQ = data['SumOfCASHCOPQ'] + data['SumOfCASHCOCQ'] )
data = data.assign(PERINSP_CQ = data['SumOfPERINSPQ'] + data['SumOfPERINSCQ'] )

print data.head()

data.to_csv("C:\\ConsumerExpenditureDemo\\Data\PythonBased\\Output\\Consumer_Exp_part1_python_groupBy_Trans_out.csv")


